> ## Documentation Index
> Fetch the complete documentation index at: https://docs.weav.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create message

> Note: API currently validates sender_type as customer|user. The API does not accept `metadata` or `is_ai_assisted` in requests.

Note: API currently validates sender_type as customer|user. The API does not accept `metadata` or `is_ai_assisted` in requests.

```http
POST https://api.weav.com/v1/messages
```

Requires a token with the `external-api:write` ability.

## Body

<ParamField body="conversation_id" type="string" required>
Format: `uuid`.
</ParamField>

<ParamField body="sender_type" type="string" required>
One of: `customer`, `user`.
</ParamField>

<ParamField body="sender_id" type="string | null">
Format: `uuid`.
</ParamField>

<ParamField body="content" type="string" required>

</ParamField>

## Request

<CodeGroup>

```bash cURL
curl --request POST \
  --url 'https://api.weav.com/v1/messages' \
  --header "Authorization: Bearer ${WEAV_API_TOKEN}" \
  --header 'Content-Type: application/json' \
  --data '{
  "conversation_id": "9b2f6c1e-3d4a-4f5b-8c7d-1e2f3a4b5c6d",
  "sender_type": "customer",
  "content": "string"
}'
```

```js JavaScript
const body = {
  "conversation_id": "9b2f6c1e-3d4a-4f5b-8c7d-1e2f3a4b5c6d",
  "sender_type": "customer",
  "content": "string"
};
const response = await fetch("https://api.weav.com/v1/messages", {
  method: "POST",
  headers: {
    Authorization: `Bearer ${process.env.WEAV_API_TOKEN}`,
    'Content-Type': 'application/json'
  },
  body: JSON.stringify(body)
});
console.log(await response.json());
```

```python Python
import os
import requests

headers = {"Authorization": f"Bearer {os.environ['WEAV_API_TOKEN']}"}
body = {"conversation_id": "9b2f6c1e-3d4a-4f5b-8c7d-1e2f3a4b5c6d", "sender_type": "customer", "content": "string"}
response = requests.post("https://api.weav.com/v1/messages", headers=headers, json=body)
print(response.json())
```

```php PHP
use GuzzleHttp\Client;

$client = new Client();
$response = $client->request('POST', 'https://api.weav.com/v1/messages', [
    'headers' => ['Authorization' => 'Bearer '.getenv('WEAV_API_TOKEN')],
    'json' => array (
  'conversation_id' => '9b2f6c1e-3d4a-4f5b-8c7d-1e2f3a4b5c6d',
  'sender_type' => 'customer',
  'content' => 'string',
),
]);
echo $response->getBody();
```

</CodeGroup>

## Response

<CodeGroup>

```json 201 Created
{
    "id": "9b2f6c1e-3d4a-4f5b-8c7d-1e2f3a4b5c6d",
    "conversation_id": "9b2f6c1e-3d4a-4f5b-8c7d-1e2f3a4b5c6d",
    "sender_type": "customer",
    "sender_id": "9b2f6c1e-3d4a-4f5b-8c7d-1e2f3a4b5c6d",
    "customer_id": "9b2f6c1e-3d4a-4f5b-8c7d-1e2f3a4b5c6d",
    "content": "string",
    "sent_at": "2026-01-01T00:00:00Z",
    "is_internal": false,
    "from": [
        "string"
    ],
    "to": [
        "string"
    ],
    "cc": [
        "string"
    ],
    "bcc": [
        "string"
    ],
    "email_status": "string",
    "email_error_message": "string",
    "created_at": "2026-01-01T00:00:00Z"
}
```

</CodeGroup>

- `400` Bad Request
- `401` Unauthorized

## Response fields

<ParamField body="id" type="string">
Format: `uuid`.
</ParamField>

<ParamField body="conversation_id" type="string">
Format: `uuid`.
</ParamField>

<ParamField body="sender_type" type="string">
One of: `customer`, `user`, `agent`, `system`.
</ParamField>

<ParamField body="sender_id" type="string | null">
Format: `uuid`.
</ParamField>

<ParamField body="customer_id" type="string | null">
Format: `uuid`.
</ParamField>

<ParamField body="content" type="string">

</ParamField>

<ParamField body="sent_at" type="string">
Format: `date-time`.
</ParamField>

<ParamField body="is_internal" type="boolean">

</ParamField>

<ParamField body="from" type="array&lt;string&gt; | null">

</ParamField>

<ParamField body="to" type="array&lt;string&gt; | null">

</ParamField>

<ParamField body="cc" type="array&lt;string&gt; | null">

</ParamField>

<ParamField body="bcc" type="array&lt;string&gt; | null">

</ParamField>

<ParamField body="email_status" type="string | null">

</ParamField>

<ParamField body="email_error_message" type="string | null">

</ParamField>

<ParamField body="created_at" type="string | null">
Format: `date-time`.
</ParamField>

---

This knowledge base is built and hosted on [Weav](https://weav.com).
